unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  DSComp, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Memo: TMemo;
    Timer: TDSTimer;
    Button2: TButton;
    Generator: TDSGenerator;
    Terminator: TDSTerminator;
    TrackBar1: TTrackBar;
    Disk1: TDSQueueOneChannelDevice;
    Disk2: TDSQueueOneChannelDevice;
    Disk3: TDSQueueOneChannelDevice;
    Channel: TDSQueueOneChannelDevice;
    procedure Button1Click(Sender: TObject);
    procedure TimerStop(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure GeneratorBeforeLeave(Sender: TObject; Transact: TTransact);
    procedure FormCreate(Sender: TObject);
    procedure GeneratorGetInterval(Sender: TObject; Transact: TTransact;
      var Interval: Integer);
    procedure Disk1IntervalQuery(Sender: TObject; Transact: TTransact;
      var Interval: Integer);
  private
    procedure TimerReset(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var Disks:array[0..2]of TDSEnterDevice;
//var Queue:TDSQueue;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer.Clear;
  RandSeed:=51;
  Timer.Start;
end;

procedure TForm1.TimerStop(Sender: TObject);
begin
  Timer.Report(Memo.Lines);
end;

procedure TForm1.TimerReset(Sender: TObject);
begin
  RandSeed:=51;
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  Timer.Events.Show(Memo.Lines);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Disk1.ReleasingDevice:=nil;
  Timer.Pause;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Timer.TimeScale:=TrackBar1.Position;
end;

procedure TForm1.GeneratorBeforeLeave(Sender: TObject;
  Transact: TTransact);
begin
  Disks[EmpDistribution([0.33,0.33,0.34])].Enter(Transact);
  Abort;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Disks[0]:=Disk1;
  Disks[1]:=Disk2;
  Disks[2]:=Disk3;
  Timer.OnReset:=TimerReset;
end;

procedure TForm1.GeneratorGetInterval(Sender: TObject; Transact: TTransact;
  var Interval: Integer);
begin
  Interval:=NegExp(40);
end;

procedure TForm1.Disk1IntervalQuery(Sender: TObject; Transact: TTransact;
  var Interval: Integer);
begin
   Interval:=IRandom(0,50);
end;

end.
