unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, 
  DSComp, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    Button1: TButton;
    Memo: TMemo;
    Timer: TDSTimer;
    Button2: TButton;
    TrackBar1: TTrackBar;
    Disk1: TDSQueueOneChannelDevice;
    Disk2: TDSQueueOneChannelDevice;
    Disk3: TDSQueueOneChannelDevice;
    Channel: TDSQueueOneChannelDevice;
    procedure Button1Click(Sender: TObject);
    procedure TimerStop(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TimerTimeEvent(Sender: TObject; Transact: TTransact;
      Device: TDSDevice; Id: Integer);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

var Disks:array[0..2]of TDSQueueOneChannelDevice;

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  //  ,      Transact.Free;
  with Channel do
    if ServisedTransact<>nil then
      Release(ServisedTransact);
  Timer.Clear;
  Timer.Start;
  Timer.Events.Add(NegExp(40),TTransact.Create,nil,1);
end;

procedure TForm1.TimerStop(Sender: TObject);
begin
  Timer.Report(Memo.Lines);
end;

procedure TForm1.TimerTimer(Sender: TObject);
begin
  Timer.Events.Show(Memo.Lines);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer.Pause;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Timer.TimeScale:=TrackBar1.Position;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Disks[0]:=Disk1;
  Disks[1]:=Disk2;
  Disks[2]:=Disk3;
end;

procedure TForm1.TimerTimeEvent(Sender: TObject; Transact: TTransact;
  Device: TDSDevice; Id: Integer);
var DiskNo:integer;
begin
  case Id of
    1:begin //
      //  
      DiskNo:=EmpDistribution([0.33,0.33,0.34]);
      with Disks[DiskNo]do
        if CanReserve(Transact) then
        begin //
          Reserve(Transact);
          // . . 
          Timer.Events.Add(Irandom(0,50),Transact,Disks[DiskNo],2);
        end
        else // 
          Enqueue(Transact);
      //    .  
      Timer.Events.Add(NegExp(40),TTransact.Create,nil,1);
    end;
    2:begin //
      with Channel do
        if CanReserve(Transact) then
        begin // 
          Reserve(Transact);
          // . . 
          Timer.Events.Add(Irandom(2,22),Transact,Device,3);
        end
        else
        begin //      
          Transact.Parent:=Device;
          Enqueue(Transact);
        end;
    end;
    3:begin //
      with Channel do
      begin
        Release(Transact); //    ,    
        if ServisedTransact<>nil then
        begin //    
          // . . 
          Timer.Events.Add(Irandom(2,22),ServisedTransact,ServisedTransact.Parent,3);
        end;
      end;
      with Device as TDSQueueOneChannelDevice do
      begin
        Release(Transact);
        if ServisedTransact<>nil then
        begin
          // . . 
          Timer.Events.Add(Irandom(0,50),ServisedTransact,Device,2);
        end;
      end;
      //  !!!
      Transact.Free;
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  //  ,      Transact.Free;
  with Channel do
    if ServisedTransact<>nil then
      Release(ServisedTransact);
end;

end.
