unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  DSComp, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Timer: TDSTimer;
    Other: TDSGenerator;
    Terminator: TDSTerminator;
    Panel1: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    TrackBar2: TTrackBar;
    Panel2: TPanel;
    Button3: TButton;
    Button4: TButton;
    Memo1: TMemo;
    Cran: TDSQueueOneChannelDevice;
    Operator: TDSGenerator;
    Fasa1: TDSAdvance;
    Fasa2: TDSAdvance;
    DSQueue1: TDSQueue;
    procedure Button1Click(Sender: TObject);
    procedure TimerStop(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure CranIntervalQuery(Sender: TObject; Transact: TTransact;
      var Interval: Integer);
    procedure Fasa1BeforeLeave(Sender: TObject; Transact: TTransact);
    procedure Fasa2BeforeLeave(Sender: TObject; Transact: TTransact);
    procedure CranBeforeLeave(Sender: TObject; Transact: TTransact);
    procedure CranBeforeEnqueue(Sender: TObject; Transact: TTransact);
    procedure CranBeforeExtract(Sender: TObject; Transact: TTransact);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button1Click(Sender: TObject);
begin
  Timer.Clear;
  Timer.Start;
end;

procedure TForm1.TimerStop(Sender: TObject);
begin
  Timer.Report(Memo1.Lines);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Timer.Pause;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Timer.TimeScale:=TrackBar2.Position;
end;

procedure TForm1.CranIntervalQuery(Sender: TObject; Transact: TTransact;
  var Interval: Integer);
begin
   if Transact.Parent=Cran then
     Interval:=IRandom(11,31)
   else if Transact.Tag=1 then
          Interval:=IRandom(8,22)
        else
          Interval:=IRandom(30,58);
end;

procedure TForm1.Fasa1BeforeLeave(Sender: TObject; Transact: TTransact);
begin
  Transact.Tag:=1;
  Transact.Priority:=2;
end;

procedure TForm1.Fasa2BeforeLeave(Sender: TObject; Transact: TTransact);
begin
  Transact.Tag:=2;
  Transact.Priority:=0;
end;

procedure TForm1.CranBeforeLeave(Sender: TObject; Transact: TTransact);
begin
   if Transact.Tag=1 then
   begin
     Fasa2.Enter(Transact);
     Abort;
   end
   else if Transact.Tag=2 then
     begin
       Fasa1.Enter(Transact);
       Abort;
     end
end;

procedure TForm1.CranBeforeEnqueue(Sender: TObject; Transact: TTransact);
begin
  if Transact.Parent=Operator then
    DSQueue1.Enqueue(Transact);
end;

procedure TForm1.CranBeforeExtract(Sender: TObject; Transact: TTransact);
begin
  if Transact.Parent=Operator then
    DSQueue1.Extract;
end;

end.
